////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// Glaskugel                                                                  //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2002-2004 by Christian Hesse                                 //
// Distributed under the terms of the GNU General Public License v2           //
////////////////////////////////////////////////////////////////////////////////

#declare Saeule = union
{
 intersection
 {
  box { <-5, 0, -5>, <5, 8, 5> }
  sphere { <0, 3, 0>, 7.1 }
 }
 box { <-5, 0, -5>, <5, 3, 5> }
 cylinder { <0, 8, 0>, <0, 35, 0>, 4 }
 torus { 4, 1 translate <0, 9, 0> }
 torus { 4, 1 translate <0, 35, 0> }
 translate <-80, 0, 0>
}

#declare Torbogen = union
{
 difference
 {
  box { <-5, 36, -22>, <5, 47, 22> }
  cylinder { <-6, 0, 0>, <6, 0, 0>, 15 scale <1, 0.3, 1> translate <0, 36, 0> }
  torus { 15, 1 rotate <0, 0, 90> scale <1, 0.3, 1> translate <5, 36, 0> }
 }
 difference
 {
  union
  {
   sphere { <0, 41, 0>, 3 }
   cylinder { <0, 45, 0>, <0, 26, 0>, 1.5 }
   difference
   {
    sphere { <0, 31, 0>, 3 }
    torus { 4.5, 3.2 translate <0, 34, 0> }
   }
   difference
   {
    sphere { <0, 26, 0>, 5.5 }
    box { <1, 32, 1>, <6, 20, 6> }
    box { <-1, 32, 1>, <-6, 20, 6> }
    box { <-1, 32, -1>, <-6, 20, -6> }
    box { <1, 32, -1>, <6, 20, -6> }
    rotate <0, 45, 0>
   }
  }
  sphere { <0, 26, 0>, 5 }
 }
 triangle { <4, 46, -23>, <4, 46, 23>, <78, 66, 0> }
 translate <-77, 0, 0> rotate <0, 15, 0>
}

#declare i = 0;
#while (i < 360)
 union
 {
  union
  {
   object { Saeule }
   object { Torbogen }
   texture { T_Grnt20 }
  }
  union
  {
   sphere
   {
    <-77, 26, 0>, 5
    finish { phong 0.7 reflection 0.1 } interior { ior 1.46 } pigment { Green filter 1 }
   }
   light_source
   {
    <-77, 26, 0>
    color Gray50 fade_distance 10 fade_power 3
   }
   rotate <0, 15, 0>
  }
  rotate <0, i, 0>
 }
 #declare i = i + 30;
#end
